=== debian/changelog ===
ros-noetic-foxglove-bridge (0.4.1-1buster) buster; urgency=high

  * Run client handler functions in separate thread (#165 <https://github.com/foxglove/ros-foxglove-bridge/issues/165>)
  * Fix compilation error due to mismatched new-delete (#163 <https://github.com/foxglove/ros-foxglove-bridge/issues/163>)
  * Decouple server implementation (#156 <https://github.com/foxglove/ros-foxglove-bridge/issues/156>)
  * ROS2 parameter fixes (#169 <https://github.com/foxglove/ros-foxglove-bridge/issues/169>)
  * Fix program crash due to unhandled exception when creating publisher with invalid topic name (#168 <https://github.com/foxglove/ros-foxglove-bridge/issues/168>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 17 Feb 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.4.0-1buster) buster; urgency=high

  * Update README with suggestion to build from source, minor fixes
  * Do not build docker images, remove corresponding documentation (#159 <https://github.com/foxglove/ros-foxglove-bridge/issues/159>)
  * Add option to use permessage-deflate compression (#152 <https://github.com/foxglove/ros-foxglove-bridge/issues/152>)
  * Improve launch file documentation, add missing launch file arguments (#158 <https://github.com/foxglove/ros-foxglove-bridge/issues/158>)
  * Allow unsetting (deleting) parameters (#145 <https://github.com/foxglove/ros-foxglove-bridge/issues/145>)
  * Improve mutex usage (#154 <https://github.com/foxglove/ros-foxglove-bridge/issues/154>)
  * Add sessionId to serverInfo (#153 <https://github.com/foxglove/ros-foxglove-bridge/issues/153>)
  * Performance improvements (#151 <https://github.com/foxglove/ros-foxglove-bridge/issues/151>)
  * Add ROS2 support for calling server-advertised services (#142 <https://github.com/foxglove/ros-foxglove-bridge/issues/142>)
  * Add ROS1 support for calling server-advertised services (#136 <https://github.com/foxglove/ros-foxglove-bridge/issues/136>)
  * ROS2 smoke test: Increase default timeout 8->10 seconds (#143 <https://github.com/foxglove/ros-foxglove-bridge/issues/143>)
  * Fix flaky parameter test (noetic) (#141 <https://github.com/foxglove/ros-foxglove-bridge/issues/141>)
  * Always --pull when building docker images in the makefile (#140 <https://github.com/foxglove/ros-foxglove-bridge/issues/140>)
  * Fix failed tests not causing CI to fail (#138 <https://github.com/foxglove/ros-foxglove-bridge/issues/138>)
  * Fix setting int / int[] parameters not working (ROS 1) (#135 <https://github.com/foxglove/ros-foxglove-bridge/issues/135>)
  * Send ROS_DISTRO to clients via metadata field (#134 <https://github.com/foxglove/ros-foxglove-bridge/issues/134>)
  * Communicate supported encodings for client-side publishing (#131 <https://github.com/foxglove/ros-foxglove-bridge/issues/131>)
  * Fix client advertised channels not being updated on unadvertise (#132 <https://github.com/foxglove/ros-foxglove-bridge/issues/132>)
  * Add support for optional request id for setParameter operation (#133 <https://github.com/foxglove/ros-foxglove-bridge/issues/133>)
  * Fix exception when setting parameter to empty array (#130 <https://github.com/foxglove/ros-foxglove-bridge/issues/130>)
  * Fix wrong parameter field names being used (#129 <https://github.com/foxglove/ros-foxglove-bridge/issues/129>)
  * Add parameter support (#112 <https://github.com/foxglove/ros-foxglove-bridge/issues/112>)
  * Add throttled logging when send buffer is full (#128 <https://github.com/foxglove/ros-foxglove-bridge/issues/128>)
  * Contributors: Hans-Joachim Krauch, John Hurliman

 -- John Hurliman <john@foxglove.dev>  Wed, 15 Feb 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.3.0-1buster) buster; urgency=high

  * Add launch files, add install instructions to README (#125 <https://github.com/foxglove/ros-foxglove-bridge/issues/125>)
  * Drop messages when connection send buffer limit has been reached (#126 <https://github.com/foxglove/ros-foxglove-bridge/issues/126>)
  * Remove references to galactic support from README (#117 <https://github.com/foxglove/ros-foxglove-bridge/issues/117>)
  * Add missing build instructions (#123 <https://github.com/foxglove/ros-foxglove-bridge/issues/123>)
  * Use a single reentrant callback group for all subscriptions (#122 <https://github.com/foxglove/ros-foxglove-bridge/issues/122>)
  * Fix clang compilation errors (#119 <https://github.com/foxglove/ros-foxglove-bridge/issues/119>)
  * Publish binary time data when use_sim_time parameter is true (#114 <https://github.com/foxglove/ros-foxglove-bridge/issues/114>)
  * Optimize Dockerfiles (#110 <https://github.com/foxglove/ros-foxglove-bridge/issues/110>)
  * Contributors: Hans-Joachim Krauch, Ruffin

 -- John Hurliman <john@foxglove.dev>  Wed, 04 Jan 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.2-1buster) buster; urgency=high

  * Fix messages not being received anymore after unadvertising a client publication (#109 <https://github.com/foxglove/ros-foxglove-bridge/issues/109>)
  * Allow to whitelist topics via a ROS paramater (#108 <https://github.com/foxglove/ros-foxglove-bridge/issues/108>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Mon, 12 Dec 2022 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.1-1buster) buster; urgency=high

  * Fix compilation on platforms where size_t is defined as unsigned int
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Mon, 05 Dec 2022 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.0-1buster) buster; urgency=high

  * Add support for client channels (#66 <https://github.com/foxglove/ros-foxglove-bridge/issues/66>)
  * Add smoke tests (#72 <https://github.com/foxglove/ros-foxglove-bridge/issues/72>)
  * Update package maintainers (#70 <https://github.com/foxglove/ros-foxglove-bridge/issues/70>)
  * [ROS2]: Fix messages not being received anymore after unsubscribing a topic (#92 <https://github.com/foxglove/ros-foxglove-bridge/issues/92>)

