=== debian/control ===
Source: ros-noetic-foxglove-bridge
Section: misc
Priority: optional
Maintainer: John Hurliman <john@foxglove.dev>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, libgtest-dev <!nocheck>, libssl-dev, libwebsocketpp-dev, nlohmann-json3-dev, ros-noetic-catkin, ros-noetic-nodelet, ros-noetic-ros-babel-fish, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-std-msgs <!nocheck>, ros-noetic-std-srvs <!nocheck>, zlib1g-dev
Homepage: https://github.com/foxglove/ros-foxglove-bridge
Standards-Version: 3.9.2

Package: ros-noetic-foxglove-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-noetic-nodelet, ros-noetic-ros-babel-fish, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, zlib1g-dev
Description: ROS Foxglove Bridge
