## ros-noetic-foxglove-bridge 0.8.4

=== debian/changelog ===
ros-noetic-foxglove-bridge (0.8.4-1focal) focal; urgency=high

  * also advertise channels for ROS1 topics without publishers (#341 <https://github.com/foxglove/ros-foxglove-bridge/issues/341>)
  * Contributors: Hans-Joachim Krauch

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Fri, 21 Feb 2025 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.3-1focal) focal; urgency=high

  * add best_effort_qos_topic_whitelist param (#329 <https://github.com/foxglove/ros-foxglove-bridge/issues/329>)
  * Add missing functional include in message_definition_cache.cpp (#334 <https://github.com/foxglove/ros-foxglove-bridge/issues/334>)
  * Contributors: David Revay, Silvio Traversaro

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Mon, 03 Feb 2025 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.2-1focal) focal; urgency=high

  * Fix "no matching function" error on yocto kirkstone (#331 <https://github.com/foxglove/ros-foxglove-bridge/issues/331>)
  * Contributors: Graham Harison

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Sun, 01 Dec 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.1-1focal) focal; urgency=high

  * Improve Error Reporting and Reduce Log Redundancy (#327 <https://github.com/foxglove/ros-foxglove-bridge/issues/327>)
  * Contributors: Robin Dumas

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Tue, 26 Nov 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.0-1focal) focal; urgency=high

  * Fix usage of deprecated AsyncParametersClient constructor (#319 <https://github.com/foxglove/ros-foxglove-bridge/issues/319>)
  * Add ROS2 JSON publishing support (#307 <https://github.com/foxglove/ros-foxglove-bridge/issues/307>)
  * Contributors: Davide Faconti, Hans-Joachim Krauch

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Wed, 31 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.10-1focal) focal; urgency=high

  * Make ROS1 service type retrieval more robust (#316 <https://github.com/foxglove/ros-foxglove-bridge/issues/316>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 12 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.9-1focal) focal; urgency=high

  * Fix parsing of IDL message definitions (#313 <https://github.com/foxglove/ros-foxglove-bridge/issues/313>)
  * Support publishing client message as loaned message (#314 <https://github.com/foxglove/ros-foxglove-bridge/issues/314>)
  * fix: remove extra ";" in websocket_server.hpp (#311 <https://github.com/foxglove/ros-foxglove-bridge/issues/311>)
  * Fix rolling smoke tests crashing (#309 <https://github.com/foxglove/ros-foxglove-bridge/issues/309>)
  * Contributors: Andrey Milko, Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 05 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.8-1focal) focal; urgency=high

  * Fix srv definition parsing failing due to carriage return (#303 <https://github.com/foxglove/ros-foxglove-bridge/issues/303>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Tue, 11 Jun 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.7-1focal) focal; urgency=high

  * send service call failure operation (#298 <https://github.com/foxglove/ros-foxglove-bridge/issues/298>)
  * Fix service definition parsing on ROS rolling (#293 <https://github.com/foxglove/ros-foxglove-bridge/issues/293>)
  * Update docs to discourage users from using websocket compression (#297 <https://github.com/foxglove/ros-foxglove-bridge/issues/297>)
  * Update README.md to remove '$ ' so that you can copy and run command (#294 <https://github.com/foxglove/ros-foxglove-bridge/issues/294>)
  * Fix typo in ROS2 launch file example (#296 <https://github.com/foxglove/ros-foxglove-bridge/issues/296>)
  * Contributors: Felipe Galindo, Hans-Joachim Krauch, Jacob Bandes-Storch, Roman Shtylman

 -- John Hurliman <john@foxglove.dev>  Tue, 21 May 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.6-1focal) focal; urgency=high

  * Fix rolling builds (#289 <https://github.com/foxglove/ros-foxglove-bridge/issues/289>)
  * Remove dual ROS 1+2 devcontainer, remove ROS Galactic from the support matrix (#285 <https://github.com/foxglove/ros-foxglove-bridge/issues/285>)
  * Contributors: Hans-Joachim Krauch, John Hurliman

 -- John Hurliman <john@foxglove.dev>  Mon, 26 Feb 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.5-1focal) focal; urgency=high

  * Add ROS 2 dependency for ament_index_cpp (#281 <https://github.com/foxglove/ros-foxglove-bridge/issues/281>)
  * Contributors: Chris Lalancette

 -- John Hurliman <john@foxglove.dev>  Fri, 29 Dec 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.4-1focal) focal; urgency=high

  * Solved bug with incompatible QoS policies
  * added explicit call to ParameterValue() to avoid clang error (#277 <https://github.com/foxglove/ros-foxglove-bridge/issues/277>)
  * Add iron release badge to readme (#271 <https://github.com/foxglove/ros-foxglove-bridge/issues/271>)
  * Contributors: Hans-Joachim Krauch, Ted

 -- John Hurliman <john@foxglove.dev>  Thu, 14 Dec 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.3-1focal) focal; urgency=high

  * Fix asset_uri_whitelist regex backtracking issue, add more extensions (#270 <https://github.com/foxglove/ros-foxglove-bridge/issues/270>)
  * [ROS1] Fix callback accessing invalid reference to promise (#268 <https://github.com/foxglove/ros-foxglove-bridge/issues/268>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Wed, 25 Oct 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.2-1focal) focal; urgency=high

  * Fix invalid pointers not being caught (#265 <https://github.com/foxglove/ros-foxglove-bridge/issues/265>)
  * Make ROS1 service type retrieval more robust (#263 <https://github.com/foxglove/ros-foxglove-bridge/issues/263>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Tue, 12 Sep 2023 00:00:00 -0000
